/* $Id: lcd.h,v 1.6 2005/02/04 10:05:31 dijkstra Exp $ */

/*
 * Copyright (c) 2003 Willem Dijkstra
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#ifndef _LCD_H
#define _LCD_H

#include <unistd.h>

/* Drivers will set LCD_X and LCD_Y */
#if defined (CF632) || defined (CF634) || defined (CF634USB)
#include "driver_cf.h"
#endif

#ifdef TEST
#include "driver_test.h"
#endif

/* LCD Capabilities */
#define LCD_HBAR         1
#define LCD_VBAR         2
#define LCD_HEARTBEAT    4
#define LCD_CONTRAST     8
#define LCD_BACKLIGHT   16

#define LCD_MAXSTR      32

#define LCD_CHAR_SPACE  32

extern char *driver_name;
extern char lcd_framebuffer[];
extern int  lcd_fd;

__BEGIN_DECLS
void lcd_beat();
void lcd_clear();
void lcd_close();
void lcd_flush();
void lcd_hbar(int, int, int, int);
void lcd_vbar(int, int, int, int);
void lcd_init(char *, int);
void lcd_printf(int, int, char*, ...);
void lcd_reboot();
int  lcd_getdimension_x();
int  lcd_getdimension_y();
void lcd_set(int, int, char);
void lcd_printfraw(char *, ...);
void lcd_printunit(int, int, int, int, double);
__END_DECLS

#endif /* _LCD_H */
